<?php
/**
 * webEdition SDK
 *
 * $Rev: 8338 $
 * $Author: mokraemer $
 * $Date: 2014-09-29 15:11:11 +0200 (Mon, 29 Sep 2014) $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 * @category   we
 * @package none
 * @subpackage we_ui_controls
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */

/**
 * Class to display a JavaMenu
 *
 * @category   we
 * @package none
 * @subpackage we_ui_controls
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
class we_ui_controls_CssMenu extends we_ui_abstract_AbstractElement{
	var $entries;
	var $lcmdFrame = "";
	var $width = 350;
	var $height = 30;
	var $menuaction = "";

	function __construct($entries, $lcmdFrame = "top.load", $menuaction = 'parent.'){
		parent::__construct();
		$this->menuaction = $menuaction;
		if($entries){
			$this->entries = $entries;
			if(we_base_browserDetect::isGecko()){
				$_SESSION['weS']['menuentries'] = $this->entries;
			}
		} else if(isset($_SESSION['weS']["menuentries"])){
			$this->entries = $_SESSION['weS']["menuentries"];
			unset($_SESSION['weS']["menuentries"]);
		}
		$this->lcmdFrame = $lcmdFrame;
	}

	protected function _renderHTML(){
		return $this->getJS() . $this->getHTMLMenu(false);
	}

	function getJS(){
		return we_html_element::jsElement('
				function menuaction(cmd) {
					weCmdController.fire({cmdName: cmd})
				}');
	}

	//remove cmdTarget in 6.4 after Java Menu is removed
	function getHTMLMenu($old = true, $cmdTarget = ''){

		// On Mozilla OSX, when the Java Menu is loaded, it is not possible to make any text input (java steels focus from input fields or e.g) so we dont show the applet.

			$out = '<span class="preload1"></span><span class="preload2"></span><span class="preload3"></span><span class="preload4"></span>' .
				'<ul id="nav">';
			$menus = array();

			foreach($this->entries as $id => $e){
			if($e['parent'] == 0){
				if(isset($e['perm']) ? we_base_menu::isEnabled($e['perm']) : 1){
					if(is_array($e["text"])){
						$mtext = ($e["text"][$GLOBALS["WE_LANGUAGE"]] ? $e["text"][$GLOBALS["WE_LANGUAGE"]] : "");
					} else {
						$mtext = ($e["text"] ? $e["text"] : "");
					}
					$menus[] = array(
						'id' => $id,
						'code' => '<li class="top" onmouseover="topMenuHover(this)"><div class="top_div" onclick="topMenuClick(this)"><a href="#void" class="top_link"><span class="down">' . $mtext . '</span></a><ul class="sub">',
					);
				}
			}
			}
			foreach($menus as $menu){
				$foo = $menu['code'];
				$this->h_pCODE($this->entries, $foo, $menu['id'], '');
				$foo .= '</ul></div></li>';
				$out .= $foo;
			}

			$out .= '</ul>';
			return $out;
	}

	function h_search($men, $p){
		$container = array();
		foreach($men as $id => $e){
			if($e["parent"] == $p){
				$container[$id] = $e;
			}
		}
		return $container;
	}

	private function h_pCODE($men, &$opt, $p, $zweig){
		$nf = self::h_search($men, $p);
		if(!empty($nf)){
			foreach($nf as $id => $e){
				$newAst = $zweig;
				$e['enabled'] = isset($e['perm']) ? we_base_menu::isEnabled($e['perm']) : 1;
				$mtext = (isset($e['text']) && is_array($e['text']) ?
						($e['text'][$GLOBALS['WE_LANGUAGE']] ? $e['text'][$GLOBALS['WE_LANGUAGE']] : '') :
						(isset($e['text']) ? $e['text'] : ''));

				if(isset($e['hide']) && $e['hide']){

				} else {
					if((!(isset($e['cmd']) && $e['cmd'])) && $mtext){
						if($e['enabled'] == 1){
							$opt .= '<li><a class="fly" href="#void">' . $mtext . '</a><ul>' . "\n";
							$this->h_pCODE($men, $opt, $id, $newAst);
							$opt .= '</ul></li>' . "\n";
						}
					} else if($mtext){
						if($e['enabled'] == 1){
							$opt .= '<li><a href="#void" onclick="' . $this->menuaction . 'menuaction(\'' . $e["cmd"] . '\')">' . $mtext . '</a></li>';
						}
					} elseif($e['enabled'] == 1){//separator
						$opt .= '<li class="disabled"></li>';
					}
				}
			}
		}
	}

}
