<?php

/**
 * webEdition CMS
 *
 * $Rev: 8380 $
 * $Author: mokraemer $
 * $Date: 2014-10-07 16:58:47 +0200 (Tue, 07 Oct 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */

/**
 * Class we_category
 *
 * Provides functions for handling webEdition category.
 */
class we_category extends weModelBase{

	var $ClassName = __CLASS__;
	var $ContentType = 'category';

	function __construct(){
		parent::__construct(CATEGORY_TABLE);
	}

	function we_save(){
		if(isset($this->Catfields) && is_array($this->Catfields)){
			$this->Catfields = serialize($this->Catfields);
		}

		parent::save();
		//FIXME:improve!
		we_navigation_cache::clean(true);
	}

	function delete(){
		$ret = parent::delete();
		//FIXME:improve!
		we_navigation_cache::clean(true);
		return $ret;
	}

	static function getCatSQLTail($catCSV = '', $table = FILE_TABLE, $catOr = false, we_database_base $db = null, $fieldName = 'Category', $getParentCats = true, $categoryids = ''){
		$db = $db ? $db : new DB_WE();
		$catCSV = trim($catCSV, ' ,');
		$pre = ' FIND_IN_SET("';
		$post = '",' . $table . '.' . $fieldName . ') ';

		$idarray = array();
		$folders = array();
		if($categoryids){
			$idarray2 = array_unique(array_map('trim', explode(',', trim($categoryids, ','))));
			$db->query('SELECT ID,IsFolder,Path FROM ' . CATEGORY_TABLE . ' WHERE ID IN(' . implode(',', $idarray2) . ')');
			while($db->next_record()){
				if($db->f('IsFolder')){
					//all folders need to be searched in deep
					$catCSV.=',' . $db->f('Path');
				} else {
					$idarray[] = $db->f('ID');
				}
			}
		}

		if($catCSV){
			$idarray1 = array_unique(array_map('trim', explode(',', trim($catCSV, ','))));
			foreach($idarray1 as $cat){
				$cat = '/' . trim($cat, '/ ');
				$isFolder = 0;
				$tmp = array();
				$db->query('SELECT ID, IsFolder FROM ' . CATEGORY_TABLE . ' WHERE Path LIKE "' . $db->escape($cat) . '/%" OR Path="' . $db->escape($cat) . '"');
				while($db->next_record()){
					$tmp[] = $db->f('ID');
					$isFolder|=$db->f('IsFolder');
				}
				if($isFolder){
					$folders[] = $tmp;
				} else {
					$idarray = array_merge($idarray, $tmp);
				}
			}
		}
		if(empty($idarray) && empty($folders)){
			return '';
		}

		$where = array();
		if(!empty($idarray)){
			$where[] = $pre . implode($post . ($catOr ? ' OR ' : ' AND ') . $pre, array_unique($idarray)) . $post;
		}
		if(!empty($folders)){
			foreach($folders as &$cur){
				$where[] = '(' . $pre . implode($post . ' OR ' . $pre, $cur) . $post . ')';
			}
			unset($cur);
		}

		return /* (empty($where) ?
			  ' AND ' . $table . '.' . $fieldName . ' = "-1" ' : */
			' AND (' . implode(($catOr ? ' OR ' : ' AND '), $where) . ' )';
	}

	static function we_getCatsFromDoc($doc, $tokken = ',', $showpath = false, we_database_base $db = null, $rootdir = '/', $catfield = '', $onlyindir = ''){
		return (isset($doc->Category) ?
				self::we_getCatsFromIDs($doc->Category, $tokken, $showpath, $db, $rootdir, $catfield, $onlyindir) :
				'');
	}

	static function we_getCatsFromIDs($catIDs, $tokken = ',', $showpath = false, we_database_base $db = null, $rootdir = '/', $catfield = '', $onlyindir = '', $asArray = false){
		if(!$catIDs){
			return $asArray ? array() : '';
		}
		$db = ($db ? $db : new DB_WE());
//$foo = makeArrayFromCSV($catIDs);
		$cats = array();
		$field = $catfield ? $catfield : ($showpath ? 'Path' : 'Category');
		$showpath &=!$catfield;
		$db->query('SELECT ID,Path,Category,Catfields FROM ' . CATEGORY_TABLE . ' WHERE ID IN(' . trim($catIDs, ',') . ')');
		while($db->next_record()){
			$data = $db->getRecord();
			if($field === 'Title' || $field === 'Description'){
				if($data['Catfields']){
					$_arr = unserialize($data['Catfields']);
					if(empty($onlyindir) || strpos($data['Path'], $onlyindir) === 0){
						$cats[] = ($field === 'Description') ? we_document::parseInternalLinks($_arr['default'][$field], 0) : $_arr['default'][$field];
					}
				} elseif(empty($onlyindir) || strpos($data['Path'], $onlyindir) === 0){
					$cats[] = '';
				}
			} elseif(empty($onlyindir) || strpos($data['Path'], $onlyindir) === 0){
				$cats[] = $data[$field];
			}
		}
		if(($showpath || $catfield === 'Path') && strlen($rootdir)){
			foreach($cats as &$cat){
				if(substr($cat, 0, strlen($rootdir)) == $rootdir){
					$cat = substr($cat, strlen($rootdir));
				}
			}
		}
		return $asArray ? $cats : makeCSVFromArray($cats, false, $tokken);
	}

}
