<?php

/**
 * webEdition CMS
 *
 * $Rev: 7998 $
 * $Author: mokraemer $
 * $Date: 2014-07-31 13:45:21 +0200 (Thu, 31 Jul 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_css($attribs){
	if(($foo = attributFehltError($attribs, 'id', __FUNCTION__))){
		return $foo;
	}

	$row = getHash('SELECT Path,IsFolder FROM ' . FILE_TABLE . ' WHERE ID=' . intval(weTag_getAttribute('id', $attribs)));
	if(!$row){
		return '';
	}

	$nolink = false;
	switch(weTag_getAttribute('applyto', $attribs, defined('CSSAPPLYTO_DEFAULT') ? CSSAPPLYTO_DEFAULT : 'around')){
		case 'around' :
			break;
		case 'wysiwyg' :
			$nolink = true;
		case 'all' :
			switch(weTag_getAttribute('media', $attribs)){
				case '':
				case 'screen':
				case 'all':
					$GLOBALS['we_doc']->addDocumentCss($row['Path']);
					break;
			}
			break;
	}
	//	remove not needed elements
	$attribs = removeAttribs($attribs, array('id', 'applyto'));

	$attribs['rel'] = weTag_getAttribute('rel', $attribs, 'stylesheet');
	$attribs['type'] = 'text/css';
	$attribs['href'] = (we_isHttps() ? '' : BASE_CSS) . $row['Path'] . ($row['IsFolder'] ? '/' : '');

	return $nolink ? '' : getHtmlTag('link', $attribs) . "\n";
}
